module: dylan-user
copyright: See LICENSE file in this distribution.

define library atk
  use dylan;
  use common-dylan;
  use c-ffi;
  use glib;
  use gobject;

  export atk;
  export atk-properties;
end library;

define module atk
  use dylan;
  use common-dylan;
  use c-ffi;
  use gobject-glue;
  use glib;
  use gobject;

  export
    atk-text-attribute-register,
    atk-text-attribute-get-value,
    atk-text-attribute-get-name,
    atk-text-attribute-for-name,
    atk-state-type-register,
    atk-state-type-get-name,
    atk-state-type-for-name,
    atk-role-register,
    atk-role-get-name,
    atk-role-get-localized-name,
    atk-role-for-name,
    atk-remove-key-event-listener,
    atk-remove-global-event-listener,
    atk-remove-focus-tracker,
    atk-relation-type-register,
    atk-relation-type-get-name,
    atk-relation-type-for-name,
    atk-get-version,
    atk-get-toolkit-version,
    atk-get-toolkit-name,
    atk-get-root,
    atk-get-focus-object,
    atk-get-default-registry,
    atk-focus-tracker-notify,
    atk-_registry-class-parent-class-setter,
    atk-_registry-class-parent-class,
    <Atk_RegistryClass>,
    atk-_registry-factory-singleton-cache-setter,
    atk-_registry-factory-singleton-cache,
    atk-_registry-factory-type-registry-setter,
    atk-_registry-factory-type-registry,
    atk-_registry-parent-setter,
    atk-_registry-parent,
    <Atk_Registry>,
    atk-_property-values-new-value-setter,
    atk-_property-values-new-value,
    atk-_property-values-old-value-setter,
    atk-_property-values-old-value,
    atk-_property-values-property-name-setter,
    atk-_property-values-property-name,
    <Atk_PropertyValues>,
    atk-window-iface-_padding-dummy,
    atk-window-iface-parent,
    <AtkWindowIface>,
    <AtkWindow*>,
    <AtkWindow>,
    atk-value-iface-pad1,
    atk-value-iface-get-minimum-increment,
    atk-value-iface-set-current-value,
    atk-value-iface-get-minimum-value,
    atk-value-iface-get-maximum-value,
    atk-value-iface-get-current-value,
    atk-value-iface-parent,
    <AtkValueIface>,
    atk-value-set-current-value,
    atk-value-get-minimum-value,
    atk-value-get-minimum-increment,
    atk-value-get-maximum-value,
    atk-value-get-current-value,
    <AtkValue*>,
    <AtkValue>,
    atk-util-class-get-toolkit-version,
    atk-util-class-get-toolkit-name,
    atk-util-class-get-root,
    atk-util-class-remove-key-event-listener,
    atk-util-class-add-key-event-listener,
    atk-util-class-remove-global-event-listener,
    atk-util-class-add-global-event-listener,
    atk-util-class-parent,
    <AtkUtilClass>,
    <AtkUtil*>,
    atk-util-parent,
    <AtkUtil>,
    atk-text-rectangle-height-setter,
    atk-text-rectangle-height,
    atk-text-rectangle-width-setter,
    atk-text-rectangle-width,
    atk-text-rectangle-y-setter,
    atk-text-rectangle-y,
    atk-text-rectangle-x-setter,
    atk-text-rectangle-x,
    <AtkTextRectangle>,
    atk-text-range-content-setter,
    atk-text-range-content,
    atk-text-range-end-offset-setter,
    atk-text-range-end-offset,
    atk-text-range-start-offset-setter,
    atk-text-range-start-offset,
    atk-text-range-bounds-setter,
    atk-text-range-bounds,
    <AtkTextRange>,
    atk-text-iface-pad4,
    atk-text-iface-get-bounded-ranges,
    atk-text-iface-get-range-extents,
    atk-text-iface-text-attributes-changed,
    atk-text-iface-text-selection-changed,
    atk-text-iface-text-caret-moved,
    atk-text-iface-text-changed,
    atk-text-iface-set-caret-offset,
    atk-text-iface-set-selection,
    atk-text-iface-remove-selection,
    atk-text-iface-add-selection,
    atk-text-iface-get-selection,
    atk-text-iface-get-n-selections,
    atk-text-iface-get-offset-at-point,
    atk-text-iface-get-character-count,
    atk-text-iface-get-character-extents,
    atk-text-iface-get-default-attributes,
    atk-text-iface-get-run-attributes,
    atk-text-iface-get-caret-offset,
    atk-text-iface-get-text-before-offset,
    atk-text-iface-get-character-at-offset,
    atk-text-iface-get-text-at-offset,
    atk-text-iface-get-text-after-offset,
    atk-text-iface-get-text,
    atk-text-iface-parent,
    <AtkTextIface>,
    <AtkTextClipType*>,
    <AtkTextClipType>,
    $atk-text-clip-both,
    $atk-text-clip-max,
    $atk-text-clip-min,
    $atk-text-clip-none,
    <AtkTextBoundary*>,
    <AtkTextBoundary>,
    $atk-text-boundary-line-end,
    $atk-text-boundary-line-start,
    $atk-text-boundary-sentence-end,
    $atk-text-boundary-sentence-start,
    $atk-text-boundary-word-end,
    $atk-text-boundary-word-start,
    $atk-text-boundary-char,
    <AtkTextAttribute*>,
    <AtkTextAttribute>,
    $atk-text-attr-last-defined,
    $atk-text-attr-style,
    $atk-text-attr-variant,
    $atk-text-attr-stretch,
    $atk-text-attr-justification,
    $atk-text-attr-direction,
    $atk-text-attr-wrap-mode,
    $atk-text-attr-fg-stipple,
    $atk-text-attr-bg-stipple,
    $atk-text-attr-fg-color,
    $atk-text-attr-bg-color,
    $atk-text-attr-family-name,
    $atk-text-attr-language,
    $atk-text-attr-weight,
    $atk-text-attr-scale,
    $atk-text-attr-size,
    $atk-text-attr-strikethrough,
    $atk-text-attr-underline,
    $atk-text-attr-rise,
    $atk-text-attr-bg-full-height,
    $atk-text-attr-pixels-inside-wrap,
    $atk-text-attr-pixels-below-lines,
    $atk-text-attr-pixels-above-lines,
    $atk-text-attr-editable,
    $atk-text-attr-invisible,
    $atk-text-attr-indent,
    $atk-text-attr-right-margin,
    $atk-text-attr-left-margin,
    $atk-text-attr-invalid,
    atk-text-set-selection,
    atk-text-set-caret-offset,
    atk-text-remove-selection,
    atk-text-get-text-before-offset,
    atk-text-get-text-at-offset,
    atk-text-get-text-after-offset,
    atk-text-get-text,
    atk-text-get-selection,
    atk-text-get-run-attributes,
    atk-text-get-range-extents,
    atk-text-get-offset-at-point,
    atk-text-get-n-selections,
    atk-text-get-default-attributes,
    atk-text-get-character-extents,
    atk-text-get-character-count,
    atk-text-get-character-at-offset,
    atk-text-get-caret-offset,
    atk-text-get-bounded-ranges,
    atk-text-add-selection,
    atk-text-free-ranges,
    <AtkText*>,
    <AtkText>,
    atk-table-iface-pad4,
    atk-table-iface-pad3,
    atk-table-iface-pad2,
    atk-table-iface-pad1,
    atk-table-iface-model-changed,
    atk-table-iface-column-reordered,
    atk-table-iface-row-reordered,
    atk-table-iface-column-deleted,
    atk-table-iface-row-deleted,
    atk-table-iface-column-inserted,
    atk-table-iface-row-inserted,
    atk-table-iface-remove-column-selection,
    atk-table-iface-add-column-selection,
    atk-table-iface-remove-row-selection,
    atk-table-iface-add-row-selection,
    atk-table-iface-is-selected,
    atk-table-iface-is-row-selected,
    atk-table-iface-is-column-selected,
    atk-table-iface-get-selected-rows,
    atk-table-iface-get-selected-columns,
    atk-table-iface-set-summary,
    atk-table-iface-set-row-header,
    atk-table-iface-set-row-description,
    atk-table-iface-set-column-header,
    atk-table-iface-set-column-description,
    atk-table-iface-set-caption,
    atk-table-iface-get-summary,
    atk-table-iface-get-row-header,
    atk-table-iface-get-row-description,
    atk-table-iface-get-column-header,
    atk-table-iface-get-column-description,
    atk-table-iface-get-caption,
    atk-table-iface-get-row-extent-at,
    atk-table-iface-get-column-extent-at,
    atk-table-iface-get-n-rows,
    atk-table-iface-get-n-columns,
    atk-table-iface-get-row-at-index,
    atk-table-iface-get-column-at-index,
    atk-table-iface-get-index-at,
    atk-table-iface-ref-at,
    atk-table-iface-parent,
    <AtkTableIface>,
    atk-table-set-summary,
    atk-table-set-row-header,
    atk-table-set-row-description,
    atk-table-set-column-header,
    atk-table-set-column-description,
    atk-table-set-caption,
    atk-table-remove-row-selection,
    atk-table-remove-column-selection,
    atk-table-ref-at,
    atk-table-is-selected,
    atk-table-is-row-selected,
    atk-table-is-column-selected,
    atk-table-get-summary,
    atk-table-get-selected-rows,
    atk-table-get-selected-columns,
    atk-table-get-row-header,
    atk-table-get-row-extent-at,
    atk-table-get-row-description,
    atk-table-get-row-at-index,
    atk-table-get-n-rows,
    atk-table-get-n-columns,
    atk-table-get-index-at,
    atk-table-get-column-header,
    atk-table-get-column-extent-at,
    atk-table-get-column-description,
    atk-table-get-column-at-index,
    atk-table-get-caption,
    atk-table-add-row-selection,
    atk-table-add-column-selection,
    <AtkTable*>,
    <AtkTable>,
    atk-streamable-content-iface-pad3,
    atk-streamable-content-iface-pad2,
    atk-streamable-content-iface-pad1,
    atk-streamable-content-iface-get-uri,
    atk-streamable-content-iface-get-stream,
    atk-streamable-content-iface-get-mime-type,
    atk-streamable-content-iface-get-n-mime-types,
    atk-streamable-content-iface-parent,
    <AtkStreamableContentIface>,
    atk-streamable-content-get-uri,
    atk-streamable-content-get-stream,
    atk-streamable-content-get-n-mime-types,
    atk-streamable-content-get-mime-type,
    <AtkStreamableContent*>,
    <AtkStreamableContent>,
    <AtkStateType*>,
    <AtkStateType>,
    $atk-state-last-defined,
    $atk-state-visited,
    $atk-state-animated,
    $atk-state-default,
    $atk-state-selectable-text,
    $atk-state-supports-autocompletion,
    $atk-state-invalid-entry,
    $atk-state-required,
    $atk-state-truncated,
    $atk-state-indeterminate,
    $atk-state-manages-descendants,
    $atk-state-visible,
    $atk-state-vertical,
    $atk-state-transient,
    $atk-state-stale,
    $atk-state-single-line,
    $atk-state-showing,
    $atk-state-sensitive,
    $atk-state-selected,
    $atk-state-selectable,
    $atk-state-resizable,
    $atk-state-pressed,
    $atk-state-opaque,
    $atk-state-multiselectable,
    $atk-state-multi-line,
    $atk-state-modal,
    $atk-state-iconified,
    $atk-state-horizontal,
    $atk-state-focused,
    $atk-state-focusable,
    $atk-state-expanded,
    $atk-state-expandable,
    $atk-state-enabled,
    $atk-state-editable,
    $atk-state-defunct,
    $atk-state-checked,
    $atk-state-busy,
    $atk-state-armed,
    $atk-state-active,
    $atk-state-invalid,
    atk-state-set-class-parent,
    <AtkStateSetClass>,
    atk-state-set-xor-sets,
    atk-state-set-remove-state,
    atk-state-set-or-sets,
    atk-state-set-is-empty,
    atk-state-set-contains-states,
    atk-state-set-contains-state,
    atk-state-set-clear-states,
    atk-state-set-and-sets,
    atk-state-set-add-states,
    atk-state-set-add-state,
    atk-state-set-new,
    <AtkStateSet*>,
    atk-state-set-parent,
    <AtkStateSet>,
    atk-socket-class-embed,
    atk-socket-class-parent-class,
    <AtkSocketClass>,
    atk-socket-is-occupied,
    atk-socket-embed,
    atk-socket-new,
    <AtkSocket*>,
    atk-socket-embedded-plug-id,
    atk-socket-parent,
    <AtkSocket>,
    atk-selection-iface-pad2,
    atk-selection-iface-pad1,
    atk-selection-iface-selection-changed,
    atk-selection-iface-select-all-selection,
    atk-selection-iface-remove-selection,
    atk-selection-iface-is-child-selected,
    atk-selection-iface-get-selection-count,
    atk-selection-iface-ref-selection,
    atk-selection-iface-clear-selection,
    atk-selection-iface-add-selection,
    atk-selection-iface-parent,
    <AtkSelectionIface>,
    atk-selection-select-all-selection,
    atk-selection-remove-selection,
    atk-selection-ref-selection,
    atk-selection-is-child-selected,
    atk-selection-get-selection-count,
    atk-selection-clear-selection,
    atk-selection-add-selection,
    <AtkSelection*>,
    <AtkSelection>,
    <AtkRole*>,
    <AtkRole>,
    $atk-role-last-defined,
    $atk-role-info-bar,
    $atk-role-notification,
    $atk-role-image-map,
    $atk-role-grouping,
    $atk-role-list-box,
    $atk-role-comment,
    $atk-role-document-email,
    $atk-role-document-web,
    $atk-role-document-text,
    $atk-role-document-presentation,
    $atk-role-document-spreadsheet,
    $atk-role-tree-item,
    $atk-role-table-row,
    $atk-role-input-method-window,
    $atk-role-link,
    $atk-role-form,
    $atk-role-redundant-object,
    $atk-role-section,
    $atk-role-page,
    $atk-role-heading,
    $atk-role-document-frame,
    $atk-role-caption,
    $atk-role-chart,
    $atk-role-entry,
    $atk-role-embedded,
    $atk-role-editbar,
    $atk-role-autocomplete,
    $atk-role-application,
    $atk-role-ruler,
    $atk-role-paragraph,
    $atk-role-footer,
    $atk-role-header,
    $atk-role-window,
    $atk-role-viewport,
    $atk-role-unknown,
    $atk-role-tree-table,
    $atk-role-tree,
    $atk-role-tool-tip,
    $atk-role-tool-bar,
    $atk-role-toggle-button,
    $atk-role-text,
    $atk-role-terminal,
    $atk-role-tear-off-menu-item,
    $atk-role-table-row-header,
    $atk-role-table-column-header,
    $atk-role-table-cell,
    $atk-role-table,
    $atk-role-statusbar,
    $atk-role-spin-button,
    $atk-role-split-pane,
    $atk-role-slider,
    $atk-role-separator,
    $atk-role-scroll-pane,
    $atk-role-scroll-bar,
    $atk-role-row-header,
    $atk-role-root-pane,
    $atk-role-radio-menu-item,
    $atk-role-radio-button,
    $atk-role-push-button,
    $atk-role-progress-bar,
    $atk-role-popup-menu,
    $atk-role-password-text,
    $atk-role-panel,
    $atk-role-page-tab-list,
    $atk-role-page-tab,
    $atk-role-option-pane,
    $atk-role-menu-item,
    $atk-role-menu-bar,
    $atk-role-menu,
    $atk-role-list-item,
    $atk-role-list,
    $atk-role-layered-pane,
    $atk-role-label,
    $atk-role-internal-frame,
    $atk-role-image,
    $atk-role-icon,
    $atk-role-html-container,
    $atk-role-glass-pane,
    $atk-role-frame,
    $atk-role-font-chooser,
    $atk-role-filler,
    $atk-role-file-chooser,
    $atk-role-drawing-area,
    $atk-role-directory-pane,
    $atk-role-dialog,
    $atk-role-dial,
    $atk-role-desktop-frame,
    $atk-role-desktop-icon,
    $atk-role-date-editor,
    $atk-role-combo-box,
    $atk-role-column-header,
    $atk-role-color-chooser,
    $atk-role-check-menu-item,
    $atk-role-check-box,
    $atk-role-canvas,
    $atk-role-calendar,
    $atk-role-arrow,
    $atk-role-animation,
    $atk-role-alert,
    $atk-role-accel-label,
    $atk-role-invalid,
    <AtkRelationType*>,
    <AtkRelationType>,
    $atk-relation-last-defined,
    $atk-relation-node-parent-of,
    $atk-relation-description-for,
    $atk-relation-described-by,
    $atk-relation-parent-window-of,
    $atk-relation-popup-for,
    $atk-relation-embedded-by,
    $atk-relation-embeds,
    $atk-relation-subwindow-of,
    $atk-relation-flows-from,
    $atk-relation-flows-to,
    $atk-relation-node-child-of,
    $atk-relation-member-of,
    $atk-relation-labelled-by,
    $atk-relation-label-for,
    $atk-relation-controller-for,
    $atk-relation-controlled-by,
    $atk-relation-null,
    atk-relation-set-class-pad2,
    atk-relation-set-class-pad1,
    atk-relation-set-class-parent,
    <AtkRelationSetClass>,
    atk-relation-set-remove,
    atk-relation-set-get-relation-by-type,
    atk-relation-set-get-relation,
    atk-relation-set-get-n-relations,
    atk-relation-set-contains,
    atk-relation-set-add-relation-by-type,
    atk-relation-set-add,
    atk-relation-set-new,
    <AtkRelationSet*>,
    atk-relation-set-relations,
    atk-relation-set-parent,
    <AtkRelationSet>,
    atk-relation-class-parent,
    <AtkRelationClass>,
    atk-relation-remove-target,
    atk-relation-get-target,
    atk-relation-get-relation-type,
    atk-relation-add-target,
    atk-relation-new,
    <AtkRelation*>,
    atk-relation-relationship,
    atk-relation-target,
    atk-relation-parent,
    <AtkRelation>,
    atk-registry-set-factory-type,
    atk-registry-get-factory-type,
    atk-registry-get-factory,
    <AtkRegistry*>,
    <AtkRegistry>,
    atk-rectangle-height-setter,
    atk-rectangle-height,
    atk-rectangle-width-setter,
    atk-rectangle-width,
    atk-rectangle-y-setter,
    atk-rectangle-y,
    atk-rectangle-x-setter,
    atk-rectangle-x,
    <AtkRectangle>,
    atk-plug-class-get-object-id,
    atk-plug-class-parent-class,
    <AtkPlugClass>,
    atk-plug-get-id,
    atk-plug-new,
    <AtkPlug*>,
    atk-plug-parent,
    <AtkPlug>,
    atk-object-factory-class-pad2,
    atk-object-factory-class-pad1,
    atk-object-factory-class-get-accessible-type,
    atk-object-factory-class-invalidate,
    atk-object-factory-class-create-accessible,
    atk-object-factory-class-parent-class,
    <AtkObjectFactoryClass>,
    atk-object-factory-invalidate,
    atk-object-factory-get-accessible-type,
    atk-object-factory-create-accessible,
    <AtkObjectFactory*>,
    atk-object-factory-parent,
    <AtkObjectFactory>,
    atk-object-class-pad2,
    atk-object-class-pad1,
    atk-object-class-get-attributes,
    atk-object-class-active-descendant-changed,
    atk-object-class-visible-data-changed,
    atk-object-class-state-change,
    atk-object-class-property-change,
    atk-object-class-focus-event,
    atk-object-class-children-changed,
    atk-object-class-initialize,
    atk-object-class-remove-property-change-handler,
    atk-object-class-connect-property-change-handler,
    atk-object-class-set-role,
    atk-object-class-set-parent,
    atk-object-class-set-description,
    atk-object-class-set-name,
    atk-object-class-ref-state-set,
    atk-object-class-get-mdi-zorder,
    atk-object-class-get-layer,
    atk-object-class-get-role,
    atk-object-class-ref-relation-set,
    atk-object-class-get-index-in-parent,
    atk-object-class-ref-child,
    atk-object-class-get-n-children,
    atk-object-class-get-parent,
    atk-object-class-get-description,
    atk-object-class-get-name,
    atk-object-class-parent,
    <AtkObjectClass>,
    atk-object-set-role,
    atk-object-set-parent,
    atk-object-set-name,
    atk-object-set-description,
    atk-object-remove-relationship,
    atk-object-remove-property-change-handler,
    atk-object-ref-state-set,
    atk-object-ref-relation-set,
    atk-object-ref-accessible-child,
    atk-object-notify-state-change,
    atk-object-initialize,
    atk-object-get-role,
    atk-object-get-parent,
    atk-object-get-name,
    atk-object-get-n-accessible-children,
    atk-object-get-index-in-parent,
    atk-object-get-description,
    atk-object-get-attributes,
    atk-object-add-relationship,
    <AtkObject*>,
    atk-object-layer,
    atk-object-relation-set,
    atk-object-role,
    atk-object-accessible-parent,
    atk-object-name,
    atk-object-description,
    atk-object-parent,
    <AtkObject>,
    atk-no-op-object-factory-class-parent-class,
    <AtkNoOpObjectFactoryClass>,
    atk-no-op-object-factory-new,
    <AtkNoOpObjectFactory*>,
    atk-no-op-object-factory-parent,
    <AtkNoOpObjectFactory>,
    atk-no-op-object-class-parent-class,
    <AtkNoOpObjectClass>,
    atk-no-op-object-new,
    <AtkNoOpObject*>,
    atk-no-op-object-parent,
    <AtkNoOpObject>,
    atk-misc-class-vfuncs,
    atk-misc-class-threads-leave,
    atk-misc-class-threads-enter,
    atk-misc-class-parent,
    <AtkMiscClass>,
    atk-misc-threads-leave,
    atk-misc-threads-enter,
    atk-misc-get-instance,
    <AtkMisc*>,
    atk-misc-parent,
    <AtkMisc>,
    <AtkLayer*>,
    <AtkLayer>,
    $atk-layer-window,
    $atk-layer-overlay,
    $atk-layer-popup,
    $atk-layer-mdi,
    $atk-layer-widget,
    $atk-layer-canvas,
    $atk-layer-background,
    $atk-layer-invalid,
    <AtkKeyEventType*>,
    <AtkKeyEventType>,
    $atk-key-event-last-defined,
    $atk-key-event-release,
    $atk-key-event-press,
    atk-key-event-struct-timestamp-setter,
    atk-key-event-struct-timestamp,
    atk-key-event-struct-keycode-setter,
    atk-key-event-struct-keycode,
    atk-key-event-struct-string-setter,
    atk-key-event-struct-string,
    atk-key-event-struct-length-setter,
    atk-key-event-struct-length,
    atk-key-event-struct-keyval-setter,
    atk-key-event-struct-keyval,
    atk-key-event-struct-state-setter,
    atk-key-event-struct-state,
    atk-key-event-struct-type-setter,
    atk-key-event-struct-type,
    <AtkKeyEventStruct>,
    <AtkImplementorIface*>,
    <AtkImplementorIface>,
    atk-implementor-ref-accessible,
    <AtkImplementor>,
    atk-image-iface-pad1,
    atk-image-iface-get-image-locale,
    atk-image-iface-set-image-description,
    atk-image-iface-get-image-size,
    atk-image-iface-get-image-description,
    atk-image-iface-get-image-position,
    atk-image-iface-parent,
    <AtkImageIface>,
    atk-image-set-image-description,
    atk-image-get-image-size,
    atk-image-get-image-position,
    atk-image-get-image-locale,
    atk-image-get-image-description,
    <AtkImage*>,
    <AtkImage>,
    atk-hypertext-iface-pad3,
    atk-hypertext-iface-pad2,
    atk-hypertext-iface-pad1,
    atk-hypertext-iface-link-selected,
    atk-hypertext-iface-get-link-index,
    atk-hypertext-iface-get-n-links,
    atk-hypertext-iface-get-link,
    atk-hypertext-iface-parent,
    <AtkHypertextIface>,
    atk-hypertext-get-n-links,
    atk-hypertext-get-link-index,
    atk-hypertext-get-link,
    <AtkHypertext*>,
    <AtkHypertext>,
    <AtkHyperlinkStateFlags*>,
    <AtkHyperlinkStateFlags>,
    $atk-hyperlink-is-inline,
    atk-hyperlink-impl-iface-pad1,
    atk-hyperlink-impl-iface-get-hyperlink,
    atk-hyperlink-impl-iface-parent,
    <AtkHyperlinkImplIface>,
    atk-hyperlink-impl-get-hyperlink,
    <AtkHyperlinkImpl*>,
    <AtkHyperlinkImpl>,
    atk-hyperlink-class-pad1,
    atk-hyperlink-class-link-activated,
    atk-hyperlink-class-is-selected-link,
    atk-hyperlink-class-link-state,
    atk-hyperlink-class-get-n-anchors,
    atk-hyperlink-class-is-valid,
    atk-hyperlink-class-get-start-index,
    atk-hyperlink-class-get-end-index,
    atk-hyperlink-class-get-object,
    atk-hyperlink-class-get-uri,
    atk-hyperlink-class-parent,
    <AtkHyperlinkClass>,
    atk-hyperlink-is-valid,
    atk-hyperlink-is-inline,
    atk-hyperlink-get-uri,
    atk-hyperlink-get-start-index,
    atk-hyperlink-get-object,
    atk-hyperlink-get-n-anchors,
    atk-hyperlink-get-end-index,
    <AtkHyperlink*>,
    atk-hyperlink-parent,
    <AtkHyperlink>,
    atk-g-object-accessible-class-pad2,
    atk-g-object-accessible-class-pad1,
    atk-g-object-accessible-class-parent-class,
    <AtkGObjectAccessibleClass>,
    atk-gobject-accessible-get-object,
    atk-gobject-accessible-for-object,
    <AtkGObjectAccessible*>,
    atk-g-object-accessible-parent,
    <AtkGObjectAccessible>,
    atk-editable-text-iface-pad2,
    atk-editable-text-iface-pad1,
    atk-editable-text-iface-paste-text,
    atk-editable-text-iface-delete-text,
    atk-editable-text-iface-cut-text,
    atk-editable-text-iface-copy-text,
    atk-editable-text-iface-insert-text,
    atk-editable-text-iface-set-text-contents,
    atk-editable-text-iface-set-run-attributes,
    atk-editable-text-iface-parent-interface,
    <AtkEditableTextIface>,
    atk-editable-text-set-text-contents,
    atk-editable-text-set-run-attributes,
    atk-editable-text-paste-text,
    atk-editable-text-insert-text,
    atk-editable-text-delete-text,
    atk-editable-text-cut-text,
    atk-editable-text-copy-text,
    <AtkEditableText*>,
    <AtkEditableText>,
    atk-document-iface-pad4,
    atk-document-iface-pad3,
    atk-document-iface-pad2,
    atk-document-iface-pad1,
    atk-document-iface-set-document-attribute,
    atk-document-iface-get-document-attribute-value,
    atk-document-iface-get-document-attributes,
    atk-document-iface-get-document-locale,
    atk-document-iface-get-document,
    atk-document-iface-get-document-type,
    atk-document-iface-parent,
    <AtkDocumentIface>,
    atk-document-set-attribute-value,
    atk-document-get-locale,
    atk-document-get-document-type,
    atk-document-get-document,
    atk-document-get-attributes,
    atk-document-get-attribute-value,
    <AtkDocument*>,
    <AtkDocument>,
    <AtkCoordType*>,
    <AtkCoordType>,
    $atk-xy-window,
    $atk-xy-screen,
    atk-component-iface-get-alpha,
    atk-component-iface-bounds-changed,
    atk-component-iface-get-mdi-zorder,
    atk-component-iface-get-layer,
    atk-component-iface-set-size,
    atk-component-iface-set-position,
    atk-component-iface-set-extents,
    atk-component-iface-remove-focus-handler,
    atk-component-iface-grab-focus,
    atk-component-iface-get-size,
    atk-component-iface-get-position,
    atk-component-iface-get-extents,
    atk-component-iface-ref-accessible-at-point,
    atk-component-iface-contains,
    atk-component-iface-add-focus-handler,
    atk-component-iface-parent,
    <AtkComponentIface>,
    atk-component-set-size,
    atk-component-set-position,
    atk-component-set-extents,
    atk-component-remove-focus-handler,
    atk-component-ref-accessible-at-point,
    atk-component-grab-focus,
    atk-component-get-size,
    atk-component-get-position,
    atk-component-get-mdi-zorder,
    atk-component-get-layer,
    atk-component-get-extents,
    atk-component-get-alpha,
    atk-component-contains,
    <AtkComponent*>,
    <AtkComponent>,
    atk-attribute-set-free,
    atk-attribute-value-setter,
    atk-attribute-value,
    atk-attribute-name-setter,
    atk-attribute-name,
    <AtkAttribute>,
    atk-action-iface-pad2,
    atk-action-iface-get-localized-name,
    atk-action-iface-set-description,
    atk-action-iface-get-keybinding,
    atk-action-iface-get-name,
    atk-action-iface-get-description,
    atk-action-iface-get-n-actions,
    atk-action-iface-do-action,
    atk-action-iface-parent,
    <AtkActionIface>,
    atk-action-set-description,
    atk-action-get-name,
    atk-action-get-n-actions,
    atk-action-get-localized-name,
    atk-action-get-keybinding,
    atk-action-get-description,
    atk-action-do-action,
    <AtkAction*>,
    <AtkAction>;
end module;

define module atk-properties
  use atk;
  use gobject-glue;

  export
    @target-setter,
    @target,
    @relation-type-setter,
    @relation-type,
    @accessible-value-setter,
    @accessible-value,
    @accessible-table-summary-setter,
    @accessible-table-summary,
    @accessible-table-row-header-setter,
    @accessible-table-row-header,
    @accessible-table-row-description-setter,
    @accessible-table-row-description,
    @accessible-table-column-header-setter,
    @accessible-table-column-header,
    @accessible-table-column-description-setter,
    @accessible-table-column-description,
    @accessible-table-caption-object-setter,
    @accessible-table-caption-object,
    @accessible-table-caption-setter,
    @accessible-table-caption,
    @accessible-role-setter,
    @accessible-role,
    @accessible-parent-setter,
    @accessible-parent,
    @accessible-name-setter,
    @accessible-name,
    @accessible-hypertext-nlinks,
    @accessible-description-setter,
    @accessible-description,
    @accessible-component-mdi-zorder,
    @accessible-component-layer,
    @start-index,
    @selected-link,
    @number-of-anchors,
    @end-index;
end module;
