Module:    dylan-user
Synopsis:  Raw Win32 OpenGL interface 
Copyright:    Original Code is Copyright (c) 1995-2004 Functional Objects, Inc.
              All rights reserved.
License:      See License.txt in this distribution for details.
Warranty:     Distributed WITHOUT WARRANTY OF ANY KIND

define module win32-gl
  use common-dylan;
  use c-ffi;
  use win32-common;

  // extras:
  export wglCreateContext, wglMakeCurrent;

  // from "GL.H":
  export <GLenum>, <GLenum*>, <GLenum**>, <GLboolean>, <GLboolean*>,
	<GLboolean**>, <GLbitfield>, <GLbitfield*>, <GLbitfield**>, <GLbyte>,
	<GLbyte*>, <GLbyte**>, <GLshort>, <GLshort*>, <GLshort**>, <GLint>,
	<GLint*>, <GLint**>, <GLsizei>, <GLsizei*>, <GLsizei**>, <GLubyte>,
	<GLubyte*>, <GLubyte**>, <GLushort>, <GLushort*>, <GLushort**>,
	<GLuint>, <GLuint*>, <GLuint**>, <GLfloat>, <GLfloat*>, <GLfloat**>,
	<GLclampf>, <GLclampf*>, <GLclampf**>, <GLdouble>, <GLdouble*>,
	<GLdouble**>, <GLclampd>, <GLclampd*>, <GLclampd**>, <GLvoid>,
	<GLvoid*>, <GLvoid**>, $GL-VERSION-1-1, $GL-ACCUM, $GL-LOAD,
	$GL-RETURN, $GL-MULT, $GL-ADD, $GL-NEVER, $GL-LESS, $GL-EQUAL,
	$GL-LEQUAL, $GL-GREATER, $GL-NOTEQUAL, $GL-GEQUAL, $GL-ALWAYS,
	$GL-CURRENT-BIT, $GL-POINT-BIT, $GL-LINE-BIT, $GL-POLYGON-BIT,
	$GL-POLYGON-STIPPLE-BIT, $GL-PIXEL-MODE-BIT, $GL-LIGHTING-BIT,
	$GL-FOG-BIT, $GL-DEPTH-BUFFER-BIT, $GL-ACCUM-BUFFER-BIT,
	$GL-STENCIL-BUFFER-BIT, $GL-VIEWPORT-BIT, $GL-TRANSFORM-BIT,
	$GL-ENABLE-BIT, $GL-COLOR-BUFFER-BIT, $GL-HINT-BIT, $GL-EVAL-BIT,
	$GL-LIST-BIT, $GL-TEXTURE-BIT, $GL-SCISSOR-BIT, $GL-ALL-ATTRIB-BITS,
	$GL-POINTS, $GL-LINES, $GL-LINE-LOOP, $GL-LINE-STRIP, $GL-TRIANGLES,
	$GL-TRIANGLE-STRIP, $GL-TRIANGLE-FAN, $GL-QUADS, $GL-QUAD-STRIP,
	$GL-POLYGON, $GL-ZERO, $GL-ONE, $GL-SRC-COLOR,
	$GL-ONE-MINUS-SRC-COLOR, $GL-SRC-ALPHA, $GL-ONE-MINUS-SRC-ALPHA,
	$GL-DST-ALPHA, $GL-ONE-MINUS-DST-ALPHA, $GL-DST-COLOR,
	$GL-ONE-MINUS-DST-COLOR, $GL-SRC-ALPHA-SATURATE, $GL-TRUE, $GL-FALSE,
	$GL-CLIP-PLANE0, $GL-CLIP-PLANE1, $GL-CLIP-PLANE2, $GL-CLIP-PLANE3,
	$GL-CLIP-PLANE4, $GL-CLIP-PLANE5, $GL-BYTE, $GL-UNSIGNED-BYTE,
	$GL-SHORT, $GL-UNSIGNED-SHORT, $GL-INT, $GL-UNSIGNED-INT, $GL-FLOAT,
	$GL-2-BYTES, $GL-3-BYTES, $GL-4-BYTES, $GL-DOUBLE, $GL-NONE,
	$GL-FRONT-LEFT, $GL-FRONT-RIGHT, $GL-BACK-LEFT, $GL-BACK-RIGHT,
	$GL-FRONT, $GL-BACK, $GL-LEFT, $GL-RIGHT, $GL-FRONT-AND-BACK,
	$GL-AUX0, $GL-AUX1, $GL-AUX2, $GL-AUX3, $GL-NO-ERROR,
	$GL-INVALID-ENUM, $GL-INVALID-VALUE, $GL-INVALID-OPERATION,
	$GL-STACK-OVERFLOW, $GL-STACK-UNDERFLOW, $GL-OUT-OF-MEMORY, $GL-2D,
	$GL-3D, $GL-3D-COLOR, $GL-3D-COLOR-TEXTURE, $GL-4D-COLOR-TEXTURE,
	$GL-PASS-THROUGH-TOKEN, $GL-POINT-TOKEN, $GL-LINE-TOKEN,
	$GL-POLYGON-TOKEN, $GL-BITMAP-TOKEN, $GL-DRAW-PIXEL-TOKEN,
	$GL-COPY-PIXEL-TOKEN, $GL-LINE-RESET-TOKEN, $GL-EXP, $GL-EXP2,
	$GL-CW, $GL-CCW, $GL-COEFF, $GL-ORDER, $GL-DOMAIN, $GL-CURRENT-COLOR,
	$GL-CURRENT-INDEX, $GL-CURRENT-NORMAL, $GL-CURRENT-TEXTURE-COORDS,
	$GL-CURRENT-RASTER-COLOR, $GL-CURRENT-RASTER-INDEX,
	$GL-CURRENT-RASTER-TEXTURE-COORDS, $GL-CURRENT-RASTER-POSITION,
	$GL-CURRENT-RASTER-POSITION-VALID, $GL-CURRENT-RASTER-DISTANCE,
	$GL-POINT-SMOOTH, $GL-POINT-SIZE, $GL-POINT-SIZE-RANGE,
	$GL-POINT-SIZE-GRANULARITY, $GL-LINE-SMOOTH, $GL-LINE-WIDTH,
	$GL-LINE-WIDTH-RANGE, $GL-LINE-WIDTH-GRANULARITY, $GL-LINE-STIPPLE,
	$GL-LINE-STIPPLE-PATTERN, $GL-LINE-STIPPLE-REPEAT, $GL-LIST-MODE,
	$GL-MAX-LIST-NESTING, $GL-LIST-BASE, $GL-LIST-INDEX,
	$GL-POLYGON-MODE, $GL-POLYGON-SMOOTH, $GL-POLYGON-STIPPLE,
	$GL-EDGE-FLAG, $GL-CULL-FACE, $GL-CULL-FACE-MODE, $GL-FRONT-FACE,
	$GL-LIGHTING, $GL-LIGHT-MODEL-LOCAL-VIEWER, $GL-LIGHT-MODEL-TWO-SIDE,
	$GL-LIGHT-MODEL-AMBIENT, $GL-SHADE-MODEL, $GL-COLOR-MATERIAL-FACE,
	$GL-COLOR-MATERIAL-PARAMETER, $GL-COLOR-MATERIAL, $GL-FOG,
	$GL-FOG-INDEX, $GL-FOG-DENSITY, $GL-FOG-START, $GL-FOG-END,
	$GL-FOG-MODE, $GL-FOG-COLOR, $GL-DEPTH-RANGE, $GL-DEPTH-TEST,
	$GL-DEPTH-WRITEMASK, $GL-DEPTH-CLEAR-VALUE, $GL-DEPTH-FUNC,
	$GL-ACCUM-CLEAR-VALUE, $GL-STENCIL-TEST, $GL-STENCIL-CLEAR-VALUE,
	$GL-STENCIL-FUNC, $GL-STENCIL-VALUE-MASK, $GL-STENCIL-FAIL,
	$GL-STENCIL-PASS-DEPTH-FAIL, $GL-STENCIL-PASS-DEPTH-PASS,
	$GL-STENCIL-REF, $GL-STENCIL-WRITEMASK, $GL-MATRIX-MODE,
	$GL-NORMALIZE, $GL-VIEWPORT, $GL-MODELVIEW-STACK-DEPTH,
	$GL-PROJECTION-STACK-DEPTH, $GL-TEXTURE-STACK-DEPTH,
	$GL-MODELVIEW-MATRIX, $GL-PROJECTION-MATRIX, $GL-TEXTURE-MATRIX,
	$GL-ATTRIB-STACK-DEPTH, $GL-CLIENT-ATTRIB-STACK-DEPTH,
	$GL-ALPHA-TEST, $GL-ALPHA-TEST-FUNC, $GL-ALPHA-TEST-REF, $GL-DITHER,
	$GL-BLEND-DST, $GL-BLEND-SRC, $GL-BLEND, $GL-LOGIC-OP-MODE,
	$GL-INDEX-LOGIC-OP, $GL-COLOR-LOGIC-OP, $GL-AUX-BUFFERS,
	$GL-DRAW-BUFFER, $GL-READ-BUFFER, $GL-SCISSOR-BOX, $GL-SCISSOR-TEST,
	$GL-INDEX-CLEAR-VALUE, $GL-INDEX-WRITEMASK, $GL-COLOR-CLEAR-VALUE,
	$GL-COLOR-WRITEMASK, $GL-INDEX-MODE, $GL-RGBA-MODE, $GL-DOUBLEBUFFER,
	$GL-STEREO, $GL-RENDER-MODE, $GL-PERSPECTIVE-CORRECTION-HINT,
	$GL-POINT-SMOOTH-HINT, $GL-LINE-SMOOTH-HINT, $GL-POLYGON-SMOOTH-HINT,
	$GL-FOG-HINT, $GL-TEXTURE-GEN-S, $GL-TEXTURE-GEN-T,
	$GL-TEXTURE-GEN-R, $GL-TEXTURE-GEN-Q, $GL-PIXEL-MAP-I-TO-I,
	$GL-PIXEL-MAP-S-TO-S, $GL-PIXEL-MAP-I-TO-R, $GL-PIXEL-MAP-I-TO-G,
	$GL-PIXEL-MAP-I-TO-B, $GL-PIXEL-MAP-I-TO-A, $GL-PIXEL-MAP-R-TO-R,
	$GL-PIXEL-MAP-G-TO-G, $GL-PIXEL-MAP-B-TO-B, $GL-PIXEL-MAP-A-TO-A,
	$GL-PIXEL-MAP-I-TO-I-SIZE, $GL-PIXEL-MAP-S-TO-S-SIZE,
	$GL-PIXEL-MAP-I-TO-R-SIZE, $GL-PIXEL-MAP-I-TO-G-SIZE,
	$GL-PIXEL-MAP-I-TO-B-SIZE, $GL-PIXEL-MAP-I-TO-A-SIZE,
	$GL-PIXEL-MAP-R-TO-R-SIZE, $GL-PIXEL-MAP-G-TO-G-SIZE,
	$GL-PIXEL-MAP-B-TO-B-SIZE, $GL-PIXEL-MAP-A-TO-A-SIZE,
	$GL-UNPACK-SWAP-BYTES, $GL-UNPACK-LSB-FIRST, $GL-UNPACK-ROW-LENGTH,
	$GL-UNPACK-SKIP-ROWS, $GL-UNPACK-SKIP-PIXELS, $GL-UNPACK-ALIGNMENT,
	$GL-PACK-SWAP-BYTES, $GL-PACK-LSB-FIRST, $GL-PACK-ROW-LENGTH,
	$GL-PACK-SKIP-ROWS, $GL-PACK-SKIP-PIXELS, $GL-PACK-ALIGNMENT,
	$GL-MAP-COLOR, $GL-MAP-STENCIL, $GL-INDEX-SHIFT, $GL-INDEX-OFFSET,
	$GL-RED-SCALE, $GL-RED-BIAS, $GL-ZOOM-X, $GL-ZOOM-Y, $GL-GREEN-SCALE,
	$GL-GREEN-BIAS, $GL-BLUE-SCALE, $GL-BLUE-BIAS, $GL-ALPHA-SCALE,
	$GL-ALPHA-BIAS, $GL-DEPTH-SCALE, $GL-DEPTH-BIAS, $GL-MAX-EVAL-ORDER,
	$GL-MAX-LIGHTS, $GL-MAX-CLIP-PLANES, $GL-MAX-TEXTURE-SIZE,
	$GL-MAX-PIXEL-MAP-TABLE, $GL-MAX-ATTRIB-STACK-DEPTH,
	$GL-MAX-MODELVIEW-STACK-DEPTH, $GL-MAX-NAME-STACK-DEPTH,
	$GL-MAX-PROJECTION-STACK-DEPTH, $GL-MAX-TEXTURE-STACK-DEPTH,
	$GL-MAX-VIEWPORT-DIMS, $GL-MAX-CLIENT-ATTRIB-STACK-DEPTH,
	$GL-SUBPIXEL-BITS, $GL-INDEX-BITS, $GL-RED-BITS, $GL-GREEN-BITS,
	$GL-BLUE-BITS, $GL-ALPHA-BITS, $GL-DEPTH-BITS, $GL-STENCIL-BITS,
	$GL-ACCUM-RED-BITS, $GL-ACCUM-GREEN-BITS, $GL-ACCUM-BLUE-BITS,
	$GL-ACCUM-ALPHA-BITS, $GL-NAME-STACK-DEPTH, $GL-AUTO-NORMAL,
	$GL-MAP1-COLOR-4, $GL-MAP1-INDEX, $GL-MAP1-NORMAL,
	$GL-MAP1-TEXTURE-COORD-1, $GL-MAP1-TEXTURE-COORD-2,
	$GL-MAP1-TEXTURE-COORD-3, $GL-MAP1-TEXTURE-COORD-4,
	$GL-MAP1-VERTEX-3, $GL-MAP1-VERTEX-4, $GL-MAP2-COLOR-4,
	$GL-MAP2-INDEX, $GL-MAP2-NORMAL, $GL-MAP2-TEXTURE-COORD-1,
	$GL-MAP2-TEXTURE-COORD-2, $GL-MAP2-TEXTURE-COORD-3,
	$GL-MAP2-TEXTURE-COORD-4, $GL-MAP2-VERTEX-3, $GL-MAP2-VERTEX-4,
	$GL-MAP1-GRID-DOMAIN, $GL-MAP1-GRID-SEGMENTS, $GL-MAP2-GRID-DOMAIN,
	$GL-MAP2-GRID-SEGMENTS, $GL-TEXTURE-1D, $GL-TEXTURE-2D,
	$GL-FEEDBACK-BUFFER-POINTER, $GL-FEEDBACK-BUFFER-SIZE,
	$GL-FEEDBACK-BUFFER-TYPE, $GL-SELECTION-BUFFER-POINTER,
	$GL-SELECTION-BUFFER-SIZE, $GL-TEXTURE-WIDTH, $GL-TEXTURE-HEIGHT,
	$GL-TEXTURE-COMPONENTS, $GL-TEXTURE-BORDER-COLOR, $GL-TEXTURE-BORDER,
	$GL-DONT-CARE, $GL-FASTEST, $GL-NICEST, $GL-LIGHT0, $GL-LIGHT1,
	$GL-LIGHT2, $GL-LIGHT3, $GL-LIGHT4, $GL-LIGHT5, $GL-LIGHT6,
	$GL-LIGHT7, $GL-AMBIENT, $GL-DIFFUSE, $GL-SPECULAR, $GL-POSITION,
	$GL-SPOT-DIRECTION, $GL-SPOT-EXPONENT, $GL-SPOT-CUTOFF,
	$GL-CONSTANT-ATTENUATION, $GL-LINEAR-ATTENUATION,
	$GL-QUADRATIC-ATTENUATION, $GL-COMPILE, $GL-COMPILE-AND-EXECUTE,
	$GL-CLEAR, $GL-AND, $GL-AND-REVERSE, $GL-COPY, $GL-AND-INVERTED,
	$GL-NOOP, $GL-XOR, $GL-OR, $GL-NOR, $GL-EQUIV, $GL-INVERT,
	$GL-OR-REVERSE, $GL-COPY-INVERTED, $GL-OR-INVERTED, $GL-NAND,
	$GL-SET, $GL-EMISSION, $GL-SHININESS, $GL-AMBIENT-AND-DIFFUSE,
	$GL-COLOR-INDEXES, $GL-MODELVIEW, $GL-PROJECTION, $GL-TEXTURE,
	$GL-COLOR, $GL-DEPTH, $GL-STENCIL, $GL-COLOR-INDEX,
	$GL-STENCIL-INDEX, $GL-DEPTH-COMPONENT, $GL-RED, $GL-GREEN, $GL-BLUE,
	$GL-ALPHA, $GL-RGB, $GL-RGBA, $GL-LUMINANCE, $GL-LUMINANCE-ALPHA,
	$GL-BITMAP, $GL-POINT, $GL-LINE, $GL-FILL, $GL-RENDER, $GL-FEEDBACK,
	$GL-SELECT, $GL-FLAT, $GL-SMOOTH, $GL-KEEP, $GL-REPLACE, $GL-INCR,
	$GL-DECR, $GL-VENDOR, $GL-RENDERER, $GL-VERSION, $GL-EXTENSIONS,
	$GL-S, $GL-T, $GL-R, $GL-Q, $GL-MODULATE, $GL-DECAL,
	$GL-TEXTURE-ENV-MODE, $GL-TEXTURE-ENV-COLOR, $GL-TEXTURE-ENV,
	$GL-EYE-LINEAR, $GL-OBJECT-LINEAR, $GL-SPHERE-MAP,
	$GL-TEXTURE-GEN-MODE, $GL-OBJECT-PLANE, $GL-EYE-PLANE, $GL-NEAREST,
	$GL-LINEAR, $GL-NEAREST-MIPMAP-NEAREST, $GL-LINEAR-MIPMAP-NEAREST,
	$GL-NEAREST-MIPMAP-LINEAR, $GL-LINEAR-MIPMAP-LINEAR,
	$GL-TEXTURE-MAG-FILTER, $GL-TEXTURE-MIN-FILTER, $GL-TEXTURE-WRAP-S,
	$GL-TEXTURE-WRAP-T, $GL-CLAMP, $GL-REPEAT,
	$GL-CLIENT-PIXEL-STORE-BIT, $GL-CLIENT-VERTEX-ARRAY-BIT,
	$GL-CLIENT-ALL-ATTRIB-BITS, $GL-POLYGON-OFFSET-FACTOR,
	$GL-POLYGON-OFFSET-UNITS, $GL-POLYGON-OFFSET-POINT,
	$GL-POLYGON-OFFSET-LINE, $GL-POLYGON-OFFSET-FILL, $GL-ALPHA4,
	$GL-ALPHA8, $GL-ALPHA12, $GL-ALPHA16, $GL-LUMINANCE4, $GL-LUMINANCE8,
	$GL-LUMINANCE12, $GL-LUMINANCE16, $GL-LUMINANCE4-ALPHA4,
	$GL-LUMINANCE6-ALPHA2, $GL-LUMINANCE8-ALPHA8, $GL-LUMINANCE12-ALPHA4,
	$GL-LUMINANCE12-ALPHA12, $GL-LUMINANCE16-ALPHA16, $GL-INTENSITY,
	$GL-INTENSITY4, $GL-INTENSITY8, $GL-INTENSITY12, $GL-INTENSITY16,
	$GL-R3-G3-B2, $GL-RGB4, $GL-RGB5, $GL-RGB8, $GL-RGB10, $GL-RGB12,
	$GL-RGB16, $GL-RGBA2, $GL-RGBA4, $GL-RGB5-A1, $GL-RGBA8,
	$GL-RGB10-A2, $GL-RGBA12, $GL-RGBA16, $GL-TEXTURE-RED-SIZE,
	$GL-TEXTURE-GREEN-SIZE, $GL-TEXTURE-BLUE-SIZE,
	$GL-TEXTURE-ALPHA-SIZE, $GL-TEXTURE-LUMINANCE-SIZE,
	$GL-TEXTURE-INTENSITY-SIZE, $GL-PROXY-TEXTURE-1D,
	$GL-PROXY-TEXTURE-2D, $GL-TEXTURE-PRIORITY, $GL-TEXTURE-RESIDENT,
	$GL-TEXTURE-BINDING-1D, $GL-TEXTURE-BINDING-2D, $GL-VERTEX-ARRAY,
	$GL-NORMAL-ARRAY, $GL-COLOR-ARRAY, $GL-INDEX-ARRAY,
	$GL-TEXTURE-COORD-ARRAY, $GL-EDGE-FLAG-ARRAY, $GL-VERTEX-ARRAY-SIZE,
	$GL-VERTEX-ARRAY-TYPE, $GL-VERTEX-ARRAY-STRIDE,
	$GL-NORMAL-ARRAY-TYPE, $GL-NORMAL-ARRAY-STRIDE, $GL-COLOR-ARRAY-SIZE,
	$GL-COLOR-ARRAY-TYPE, $GL-COLOR-ARRAY-STRIDE, $GL-INDEX-ARRAY-TYPE,
	$GL-INDEX-ARRAY-STRIDE, $GL-TEXTURE-COORD-ARRAY-SIZE,
	$GL-TEXTURE-COORD-ARRAY-TYPE, $GL-TEXTURE-COORD-ARRAY-STRIDE,
	$GL-EDGE-FLAG-ARRAY-STRIDE, $GL-VERTEX-ARRAY-POINTER,
	$GL-NORMAL-ARRAY-POINTER, $GL-COLOR-ARRAY-POINTER,
	$GL-INDEX-ARRAY-POINTER, $GL-TEXTURE-COORD-ARRAY-POINTER,
	$GL-EDGE-FLAG-ARRAY-POINTER, $GL-V2F, $GL-V3F, $GL-C4UB-V2F,
	$GL-C4UB-V3F, $GL-C3F-V3F, $GL-N3F-V3F, $GL-C4F-N3F-V3F, $GL-T2F-V3F,
	$GL-T4F-V4F, $GL-T2F-C4UB-V3F, $GL-T2F-C3F-V3F, $GL-T2F-N3F-V3F,
	$GL-T2F-C4F-N3F-V3F, $GL-T4F-C4F-N3F-V4F, $GL-EXT-vertex-array,
	$GL-WIN-swap-hint, $GL-EXT-bgra, $GL-EXT-paletted-texture,
	$GL-EXT-clip-disable, $GL-VERTEX-ARRAY-EXT, $GL-NORMAL-ARRAY-EXT,
	$GL-COLOR-ARRAY-EXT, $GL-INDEX-ARRAY-EXT,
	$GL-TEXTURE-COORD-ARRAY-EXT, $GL-EDGE-FLAG-ARRAY-EXT,
	$GL-VERTEX-ARRAY-SIZE-EXT, $GL-VERTEX-ARRAY-TYPE-EXT,
	$GL-VERTEX-ARRAY-STRIDE-EXT, $GL-VERTEX-ARRAY-COUNT-EXT,
	$GL-NORMAL-ARRAY-TYPE-EXT, $GL-NORMAL-ARRAY-STRIDE-EXT,
	$GL-NORMAL-ARRAY-COUNT-EXT, $GL-COLOR-ARRAY-SIZE-EXT,
	$GL-COLOR-ARRAY-TYPE-EXT, $GL-COLOR-ARRAY-STRIDE-EXT,
	$GL-COLOR-ARRAY-COUNT-EXT, $GL-INDEX-ARRAY-TYPE-EXT,
	$GL-INDEX-ARRAY-STRIDE-EXT, $GL-INDEX-ARRAY-COUNT-EXT,
	$GL-TEXTURE-COORD-ARRAY-SIZE-EXT, $GL-TEXTURE-COORD-ARRAY-TYPE-EXT,
	$GL-TEXTURE-COORD-ARRAY-STRIDE-EXT,
	$GL-TEXTURE-COORD-ARRAY-COUNT-EXT, $GL-EDGE-FLAG-ARRAY-STRIDE-EXT,
	$GL-EDGE-FLAG-ARRAY-COUNT-EXT, $GL-VERTEX-ARRAY-POINTER-EXT,
	$GL-NORMAL-ARRAY-POINTER-EXT, $GL-COLOR-ARRAY-POINTER-EXT,
	$GL-INDEX-ARRAY-POINTER-EXT, $GL-TEXTURE-COORD-ARRAY-POINTER-EXT,
	$GL-EDGE-FLAG-ARRAY-POINTER-EXT, $GL-DOUBLE-EXT, $GL-BGR-EXT,
	$GL-BGRA-EXT, $GL-COLOR-TABLE-FORMAT-EXT, $GL-COLOR-TABLE-WIDTH-EXT,
	$GL-COLOR-TABLE-RED-SIZE-EXT, $GL-COLOR-TABLE-GREEN-SIZE-EXT,
	$GL-COLOR-TABLE-BLUE-SIZE-EXT, $GL-COLOR-TABLE-ALPHA-SIZE-EXT,
	$GL-COLOR-TABLE-LUMINANCE-SIZE-EXT,
	$GL-COLOR-TABLE-INTENSITY-SIZE-EXT, $GL-COLOR-INDEX1-EXT,
	$GL-COLOR-INDEX2-EXT, $GL-COLOR-INDEX4-EXT, $GL-COLOR-INDEX8-EXT,
	$GL-COLOR-INDEX12-EXT, $GL-COLOR-INDEX16-EXT, $GL-CLIP-EXT,
	$GL-LOGIC-OP, glAccum, glAlphaFunc, glAreTexturesResident,
	glArrayElement, glBegin, glBindTexture, glBitmap, glBlendFunc,
	glCallList, glCallLists, glClear, glClearAccum, glClearColor,
	glClearDepth, glClearIndex, glClearStencil, glClipPlane, glColor3b,
	glColor3bv, glColor3d, glColor3dv, glColor3f, glColor3fv, glColor3i,
	glColor3iv, glColor3s, glColor3sv, glColor3ub, glColor3ubv,
	glColor3ui, glColor3uiv, glColor3us, glColor3usv, glColor4b,
	glColor4bv, glColor4d, glColor4dv, glColor4f, glColor4fv, glColor4i,
	glColor4iv, glColor4s, glColor4sv, glColor4ub, glColor4ubv,
	glColor4ui, glColor4uiv, glColor4us, glColor4usv, glColorMask,
	glColorMaterial, glColorPointer, glCopyPixels, glCopyTexImage1D,
	glCopyTexImage2D, glCopyTexSubImage1D, glCopyTexSubImage2D,
	glCullFace, glDeleteLists, glDeleteTextures, glDepthFunc,
	glDepthMask, glDepthRange, glDisable, glDisableClientState,
	glDrawArrays, glDrawBuffer, glDrawElements, glDrawPixels, glEdgeFlag,
	glEdgeFlagPointer, glEdgeFlagv, glEnable, glEnableClientState, glEnd,
	glEndList, glEvalCoord1d, glEvalCoord1dv, glEvalCoord1f,
	glEvalCoord1fv, glEvalCoord2d, glEvalCoord2dv, glEvalCoord2f,
	glEvalCoord2fv, glEvalMesh1, glEvalMesh2, glEvalPoint1, glEvalPoint2,
	glFeedbackBuffer, glFinish, glFlush, glFogf, glFogfv, glFogi,
	glFogiv, glFrontFace, glFrustum, glGenLists, glGenTextures,
	glGetBooleanv, glGetClipPlane, glGetDoublev, glGetError, glGetFloatv,
	glGetIntegerv, glGetLightfv, glGetLightiv, glGetMapdv, glGetMapfv,
	glGetMapiv, glGetMaterialfv, glGetMaterialiv, glGetPixelMapfv,
	glGetPixelMapuiv, glGetPixelMapusv, glGetPointerv,
	glGetPolygonStipple, glGetString, glGetTexEnvfv, glGetTexEnviv,
	glGetTexGendv, glGetTexGenfv, glGetTexGeniv, glGetTexImage,
	glGetTexLevelParameterfv, glGetTexLevelParameteriv,
	glGetTexParameterfv, glGetTexParameteriv, glHint, glIndexMask,
	glIndexPointer, glIndexd, glIndexdv, glIndexf, glIndexfv, glIndexi,
	glIndexiv, glIndexs, glIndexsv, glIndexub, glIndexubv, glInitNames,
	glInterleavedArrays, glIsEnabled, glIsList, glIsTexture,
	glLightModelf, glLightModelfv, glLightModeli, glLightModeliv,
	glLightf, glLightfv, glLighti, glLightiv, glLineStipple, glLineWidth,
	glListBase, glLoadIdentity, glLoadMatrixd, glLoadMatrixf, glLoadName,
	glLogicOp, glMap1d, glMap1f, glMap2d, glMap2f, glMapGrid1d,
	glMapGrid1f, glMapGrid2d, glMapGrid2f, glMaterialf, glMaterialfv,
	glMateriali, glMaterialiv, glMatrixMode, glMultMatrixd,
	glMultMatrixf, glNewList, glNormal3b, glNormal3bv, glNormal3d,
	glNormal3dv, glNormal3f, glNormal3fv, glNormal3i, glNormal3iv,
	glNormal3s, glNormal3sv, glNormalPointer, glOrtho, glPassThrough,
	glPixelMapfv, glPixelMapuiv, glPixelMapusv, glPixelStoref,
	glPixelStorei, glPixelTransferf, glPixelTransferi, glPixelZoom,
	glPointSize, glPolygonMode, glPolygonOffset, glPolygonStipple,
	glPopAttrib, glPopClientAttrib, glPopMatrix, glPopName,
	glPrioritizeTextures, glPushAttrib, glPushClientAttrib, glPushMatrix,
	glPushName, glRasterPos2d, glRasterPos2dv, glRasterPos2f,
	glRasterPos2fv, glRasterPos2i, glRasterPos2iv, glRasterPos2s,
	glRasterPos2sv, glRasterPos3d, glRasterPos3dv, glRasterPos3f,
	glRasterPos3fv, glRasterPos3i, glRasterPos3iv, glRasterPos3s,
	glRasterPos3sv, glRasterPos4d, glRasterPos4dv, glRasterPos4f,
	glRasterPos4fv, glRasterPos4i, glRasterPos4iv, glRasterPos4s,
	glRasterPos4sv, glReadBuffer, glReadPixels, glRectd, glRectdv,
	glRectf, glRectfv, glRecti, glRectiv, glRects, glRectsv,
	glRenderMode, glRotated, glRotatef, glScaled, glScalef, glScissor,
	glSelectBuffer, glShadeModel, glStencilFunc, glStencilMask,
	glStencilOp, glTexCoord1d, glTexCoord1dv, glTexCoord1f,
	glTexCoord1fv, glTexCoord1i, glTexCoord1iv, glTexCoord1s,
	glTexCoord1sv, glTexCoord2d, glTexCoord2dv, glTexCoord2f,
	glTexCoord2fv, glTexCoord2i, glTexCoord2iv, glTexCoord2s,
	glTexCoord2sv, glTexCoord3d, glTexCoord3dv, glTexCoord3f,
	glTexCoord3fv, glTexCoord3i, glTexCoord3iv, glTexCoord3s,
	glTexCoord3sv, glTexCoord4d, glTexCoord4dv, glTexCoord4f,
	glTexCoord4fv, glTexCoord4i, glTexCoord4iv, glTexCoord4s,
	glTexCoord4sv, glTexCoordPointer, glTexEnvf, glTexEnvfv, glTexEnvi,
	glTexEnviv, glTexGend, glTexGendv, glTexGenf, glTexGenfv, glTexGeni,
	glTexGeniv, glTexImage1D, glTexImage2D, glTexParameterf,
	glTexParameterfv, glTexParameteri, glTexParameteriv, glTexSubImage1D,
	glTexSubImage2D, glTranslated, glTranslatef, glVertex2d, glVertex2dv,
	glVertex2f, glVertex2fv, glVertex2i, glVertex2iv, glVertex2s,
	glVertex2sv, glVertex3d, glVertex3dv, glVertex3f, glVertex3fv,
	glVertex3i, glVertex3iv, glVertex3s, glVertex3sv, glVertex4d,
	glVertex4dv, glVertex4f, glVertex4fv, glVertex4i, glVertex4iv,
	glVertex4s, glVertex4sv, glVertexPointer, glViewport,
	<PFNGLARRAYELEMENTEXTPROC>, <PFNGLDRAWARRAYSEXTPROC>,
	<PFNGLVERTEXPOINTEREXTPROC>, <PFNGLNORMALPOINTEREXTPROC>,
	<PFNGLCOLORPOINTEREXTPROC>, <PFNGLINDEXPOINTEREXTPROC>,
	<PFNGLTEXCOORDPOINTEREXTPROC>, <PFNGLEDGEFLAGPOINTEREXTPROC>,
	<PFNGLGETPOINTERVEXTPROC>, <PFNGLARRAYELEMENTARRAYEXTPROC>,
	<PFNGLADDSWAPHINTRECTWINPROC>, <PFNGLCOLORTABLEEXTPROC>,
	<PFNGLCOLORSUBTABLEEXTPROC>, <PFNGLGETCOLORTABLEEXTPROC>,
	<PFNGLGETCOLORTABLEPARAMETERIVEXTPROC>,
	<PFNGLGETCOLORTABLEPARAMETERFVEXTPROC>;

end module win32-gl;
